import java.util.*;

public class SetPartition<T> {
  ArrayList<T> list = new ArrayList<>();
  ArrayList<Integer> last = new ArrayList<>();
  
  public SetPartition() {}
  
  public int size() { return list.size(); } // optional method
  public int size(T elem) {
    int i = list.indexOf(elem);
    if (i < 0) return 0;
    
    Integer j = last.get(i);
    return j-i+1;
  }
  
  public boolean sameSubSet(T elem1, T elem2) {
    int i = list.indexOf(elem1);
    int j = list.indexOf(elem2);
    
    if (i <= j && j <= last.get(i)) return true;
    if (j <= i && i <= last.get(j)) return true;
    return false;
  }
  
  public void merge(T elem1, T elem2) {
    int i1 = list.indexOf(elem1);
    int i2 = list.indexOf(elem2);
    if (i1 < 0 || i2 < 0) return;

    int m1 = last.get(i1);
    int m2 = last.get(i2);
    int max = (m1 > m2) ? m1 : m2;
    
    last.set(i1, max);
    last.set(i2, max);
  }

  public void add(T elem) {
    last.add( list.size() );
    list.add(elem);
  }
  
  public void remove(T elem) { // option method
    int i = list.indexOf(elem);
    if (i < 0) return;
    
    for (int j = 0;  j < last.size();  j++) {
      int k = last.get(j);
      if (k >= i) 
          last.set(j, k-1);
    }
    list.remove(i);
    last.remove(i);
  }
  
  public String subsetString(int i, int j) { // optional method
    String result = "{";
    for (int k = i;  k <= j;  k++) {
      if (k > i) result += ", ";
      result += list.get(k).toString();
    }
    return result + "}";
  }
  
  public String toString() { // optional method
    String result = "";
    for (int i = 0;  i < list.size();  i++) {
      int j = last.get(i);
      if (i > 0) result += ", ";
      result += subsetString(i, j);
      i = j;
    }
  
    return result;
  }
  
}